package syscon.arbutus.product.services.legal.contract.dto;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * The representation of the case identifier type in a case.
 *
 * @author lhan
 */
public class CaseIdentifierType implements Serializable {

    private static final long serialVersionUID = -7652533228992451738L;

    private Long caseIdentifierId;
    @NotNull
    private String identifierType;
    @NotNull
    private String identifierValue;
    private Long sourceOrganizationId;
    private Long sourceFacilityId;

    /**
     * Check if properties are set properly. A empty string is treated as null.
     * <p>caseIdentifierType and identifierValue are not null. </p>
     *
     * @return boolean Return true if all required properties are set, false otherwise.
     */
    @Deprecated
    public boolean isWellFormed() {

        if (ValidationUtil.isEmpty(identifierType) || ValidationUtil.isEmpty(identifierValue)) {
			return false;
		}

        return true;
    }

    /**
     * Verify if properties are set properly.
     * <p>Max length of identifierType is 64.</p>
     * <p>Max length of identifierValue is 64.</p>
     *
     * @return boolean Return true if all required properties are set and all values are valid, false otherwise.
     */
    @Deprecated
    public boolean isValid() {

        if (!isWellFormed()) {
			return false;
		}

        if (!ValidationUtil.isValidCode(identifierType)) {
			return false;
		}

        if (!ValidationUtil.isValidCode(identifierValue)) {
			return false;
		}

        return true;
    }

    /**
     * @return the caseIdentifierId
     */
    public Long getCaseIdentifierId() {
        return caseIdentifierId;
    }

    /**
     * The unique Id for each case identifier record. It is generated by service and should not be changed by client.
     *
     * @param caseIdentifierId the caseIdentifierId to set
     */
    public void setCaseIdentifierId(Long caseIdentifierId) {
        this.caseIdentifierId = caseIdentifierId;
    }

    /**
     * @return the identifierTypeCode
     */
    public String getIdentifierType() {
        return identifierType;
    }

    /**
     * A kind of identifier or number that can be associated to a criminal case e.g. Court Information Number, Indictment Number.
     * The value should be one of the reference code in the CaseIdentifierType reference set. (required)
     *
     * @param identifierType the identifierTypeCode to set
     */
    public void setIdentifierType(String identifierType) {
        this.identifierType = identifierType;
    }

    /**
     * @return the identifierValue
     */
    public String getIdentifierValue() {
        return identifierValue;
    }

    /**
     * The number or value of the case identifier e.g. 1234567S (required)
     *
     * @param identifierValue the identifierValue to set
     */
    public void setIdentifierValue(String identifierValue) {
        this.identifierValue = identifierValue;
    }

    /**
     * @return the sourceOrganizationId
     */
    public Long getSourceOrganizationId() {
        return sourceOrganizationId;
    }

    /**
     * The organization Id, static reference to an organization which issued the case identifier. (Optional)
     *
     * @param sourceOrganizationId the sourceOrganizationId to set
     */
    public void setSourceOrganizationId(Long sourceOrganizationId) {
        this.sourceOrganizationId = sourceOrganizationId;
    }

    /**
     * @return the sourceFacilityId
     */
    public Long getSourceFacilityId() {
        return sourceFacilityId;
    }

    /**
     * The facility Id, static reference to a facility which issued the case identifier. (Optional)
     *
     * @param sourceFacilityId the sourceFacilityId to set
     */
    public void setSourceFacilityId(Long sourceFacilityId) {
        this.sourceFacilityId = sourceFacilityId;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((identifierType == null) ? 0 : identifierType.hashCode());
        result = prime * result + ((identifierValue == null) ? 0 : identifierValue.hashCode());
        result = prime * result + ((sourceFacilityId == null) ? 0 : sourceFacilityId.hashCode());
        result = prime * result + ((sourceOrganizationId == null) ? 0 : sourceOrganizationId.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
			return true;
		}
        if (obj == null) {
			return false;
		}
        if (getClass() != obj.getClass()) {
			return false;
		}
        CaseIdentifierType other = (CaseIdentifierType) obj;
        if (identifierType == null) {
            if (other.identifierType != null) {
				return false;
			}
        } else if (!identifierType.equals(other.identifierType)) {
			return false;
		}
        if (identifierValue == null) {
            if (other.identifierValue != null) {
				return false;
			}
        } else if (!identifierValue.equals(other.identifierValue)) {
			return false;
		}
        if (sourceFacilityId == null) {
            if (other.sourceFacilityId != null) {
				return false;
			}
        } else if (!sourceFacilityId.equals(other.sourceFacilityId)) {
			return false;
		}
        if (sourceOrganizationId == null) {
            if (other.sourceOrganizationId != null) {
				return false;
			}
        } else if (!sourceOrganizationId.equals(other.sourceOrganizationId)) {
			return false;
		}
        return true;
    }

    @Override
    public String toString() {
        return "CaseIdentifierType [getCaseIdentifierId()=" + getCaseIdentifierId() + ", getIdentifierType()=" + getIdentifierType() + ", getIdentifierValue()="
                + getIdentifierValue() + ", getSourceOrganizationId()=" + getSourceOrganizationId() + ", getSourceFacilityId()=" + getSourceFacilityId()
                + ", getCreatedDate()=" + "]";
    }

}
